searchNodes=[{"doc":"Documentation for Punt .","ref":"Punt.html","title":"Punt","type":"module"},{"doc":"Apply parser, and then decide what to do Useful for conditional parsing based on result of previous parse","ref":"Punt.html#and_then/2","title":"Punt.and_then/2","type":"function"},{"doc":"Parse a boolean Example iex&gt; Punt . boolean ( ) |&gt; Punt . parse ( true ) { :ok , true } iex&gt; Punt . boolean ( ) |&gt; Punt . parse ( false ) { :ok , false } iex&gt; Punt . boolean ( ) |&gt; Punt . parse ( &quot;foo&quot; ) { :error , :not_a_boolean }","ref":"Punt.html#boolean/0","title":"Punt.boolean/0","type":"function"},{"doc":"","ref":"Punt.html#build/1","title":"Punt.build/1","type":"function"},{"doc":"Always failing parser","ref":"Punt.html#fail/1","title":"Punt.fail/1","type":"function"},{"doc":"Parse a float Example iex&gt; Punt . float ( ) |&gt; Punt . parse ( 3.4 ) { :ok , 3.4 } iex&gt; Punt . float ( ) |&gt; Punt . parse ( 3 ) { :error , :not_a_float } iex&gt; Punt . float ( ) |&gt; Punt . parse ( &quot;foo&quot; ) { :error , :not_a_float }","ref":"Punt.html#float/0","title":"Punt.float/0","type":"function"},{"doc":"","ref":"Punt.html#gen/1","title":"Punt.gen/1","type":"function"},{"doc":"Parse a map key Example iex&gt; Punt . get ( :name , Punt . string ) |&gt; Punt . parse ( %{ name : &quot;foo&quot; } ) { :ok , &quot;foo&quot; } iex&gt; Punt . get ( :name , Punt . string ) |&gt; Punt . parse ( %{ bar : &quot;foo&quot; } ) { :error , %{ code : :no_such_get , field : :name , input : %{ bar : &quot;foo&quot; } } }","ref":"Punt.html#get/2","title":"Punt.get/2","type":"function"},{"doc":"Gets a nested value from nested maps Example iex&gt; Punt . get_in ( [ :a , :b ] , Punt . number ( ) ) |&gt; Punt . parse ( %{ a : %{ b : 123 } } ) { :ok , 123 }","ref":"Punt.html#get_in/2","title":"Punt.get_in/2","type":"function"},{"doc":"Parse a map, fallback to default Example iex&gt; Punt . get_or_missing ( :name , &quot;default&quot; , Punt . string ) |&gt; Punt . parse ( %{ name : &quot;foo&quot; } ) { :ok , &quot;foo&quot; } iex&gt; Punt . get_or_missing ( :name , &quot;default&quot; , Punt . string ) |&gt; Punt . parse ( %{ bar : &quot;foo&quot; } ) { :ok , &quot;default&quot; }","ref":"Punt.html#get_or_missing/3","title":"Punt.get_or_missing/3","type":"function"},{"doc":"Parse a value at index Example iex&gt; Punt . index ( 2 , Punt . number ) |&gt; Punt . parse ( [ 1 , 2 , 3 ] ) { :ok , 3 } iex&gt; Punt . index ( 10 , Punt . number ) |&gt; Punt . parse ( [ 1 , 2 , 3 ] ) { :error , :not_a_number }","ref":"Punt.html#index/2","title":"Punt.index/2","type":"function"},{"doc":"Parse a integer Example iex&gt; Punt . integer ( ) |&gt; Punt . parse ( 3 ) { :ok , 3 } iex&gt; Punt . integer ( ) |&gt; Punt . parse ( 3.4 ) { :error , :not_an_integer } iex&gt; Punt . integer ( ) |&gt; Punt . parse ( &quot;foo&quot; ) { :error , :not_an_integer }","ref":"Punt.html#integer/1","title":"Punt.integer/1","type":"function"},{"doc":"Parse a list Example iex&gt; Punt . list_of ( Punt . string ) |&gt; Punt . parse ( [ &quot;foo&quot; , &quot;bar&quot; ] ) { :ok , [ &quot;foo&quot; , &quot;bar&quot; ] } iex&gt; Punt . list_of ( Punt . string ) |&gt; Punt . parse ( [ &quot;foo&quot; , 1 ] ) { :error , %{ details : :not_a_string , failed_element : 1 } }","ref":"Punt.html#list_of/2","title":"Punt.list_of/2","type":"function"},{"doc":"","ref":"Punt.html#map/2","title":"Punt.map/2","type":"function"},{"doc":"Apply parser and map over result Example iex&gt; Punt . map ( Punt . string ( ) , &amp; String . to_integer ( &amp;1 ) ) |&gt; Punt . parse ( &quot;123&quot; )","ref":"Punt.html#map/3","title":"Punt.map/3","type":"function"},{"doc":"Parse into a map or struct Example iex&gt; Punt . new ( [ a : Punt . get ( :b , Punt . string ) ] , %{ b : &quot;foo&quot; } ) { :ok , %{ a : &quot;foo&quot; } }","ref":"Punt.html#new/3","title":"Punt.new/3","type":"function"},{"doc":"Parse a nil Example iex&gt; Punt . null ( ) |&gt; Punt . parse ( nil ) { :ok , nil } iex&gt; Punt . null ( ) |&gt; Punt . parse ( &quot;foo&quot; ) { :error , :not_a_null }","ref":"Punt.html#null/0","title":"Punt.null/0","type":"function"},{"doc":"Parse a number Example iex&gt; Punt . number ( ) |&gt; Punt . parse ( 3.4 ) { :ok , 3.4 } iex&gt; Punt . number ( ) |&gt; Punt . parse ( 3 ) { :ok , 3 } iex&gt; Punt . number ( ) |&gt; Punt . parse ( &quot;foo&quot; ) { :error , :not_a_number }","ref":"Punt.html#number/0","title":"Punt.number/0","type":"function"},{"doc":"Parse into a map Example iex&gt; Punt . of_map ( [ a : Punt . get ( :b , Punt . string ) ] ) |&gt; Punt . parse ( %{ b : &quot;foo&quot; } ) { :ok , %{ a : &quot;foo&quot; } }","ref":"Punt.html#of_map/1","title":"Punt.of_map/1","type":"function"},{"doc":"Parse into a struct Example iex&gt; Punt . of_struct ( [ a : Punt . get ( :b , Punt . string ) ] , A ) |&gt; Punt . parse ( %{ b : &quot;foo&quot; } ) { :ok , % PuntTest.A { a : &quot;foo&quot; } }","ref":"Punt.html#of_struct/2","title":"Punt.of_struct/2","type":"function"},{"doc":"Chooses one of the given parser Example iex&gt; Punt . one_of ( [ Punt . null ( ) , Punt . integer ( ) ] ) |&gt; Punt . parse ( 123 ) { :ok , 123 } iex&gt; Punt . one_of ( [ Punt . null ( ) , Punt . integer ( ) ] ) |&gt; Punt . parse ( nil ) { :ok , nil }","ref":"Punt.html#one_of/1","title":"Punt.one_of/1","type":"function"},{"doc":"Parse a pair Example iex&gt; Punt . pair_of ( Punt . string , Punt . string ) |&gt; Punt . parse ( [ &quot;foo&quot; , &quot;bar&quot; ] ) { :ok , { &quot;foo&quot; , &quot;bar&quot; } }","ref":"Punt.html#pair_of/2","title":"Punt.pair_of/2","type":"function"},{"doc":"","ref":"Punt.html#parse/2","title":"Punt.parse/2","type":"function"},{"doc":"Check whether a value holds for the input Example iex&gt; Punt . predicate ( &amp; &amp;1 == 123 ) |&gt; Punt . parse ( 123 ) { :ok , 123 } iex&gt; Punt . predicate ( &amp; &amp;1 != 123 ) |&gt; Punt . parse ( 123 ) { :error , %{ context : [ ] , input : 123 , reason : :predicate_failed } }","ref":"Punt.html#predicate/2","title":"Punt.predicate/2","type":"function"},{"doc":"Parse a pair Example iex&gt; Punt . singleton_of ( Punt . string ) |&gt; Punt . parse ( [ &quot;foo&quot; ] ) { :ok , &quot;foo&quot; }","ref":"Punt.html#singleton_of/1","title":"Punt.singleton_of/1","type":"function"},{"doc":"Parse a string Example iex&gt; Punt . string ( ) |&gt; Punt . parse ( &quot;foo&quot; ) { :ok , &quot;foo&quot; } iex&gt; Punt . string ( ) |&gt; Punt . parse ( 3.4 ) { :error , :not_a_string } iex&gt; Punt . string ( ) |&gt; Punt . parse ( 3 ) { :error , :not_a_string }","ref":"Punt.html#string/1","title":"Punt.string/1","type":"function"},{"doc":"Always succeeding parser","ref":"Punt.html#succeed/1","title":"Punt.succeed/1","type":"function"},{"doc":"","ref":"Punt.html#to_parser/1","title":"Punt.to_parser/1","type":"function"},{"doc":"Returns value you put in Example iex&gt; Punt . value ( ) |&gt; Punt . parse ( &quot;123&quot; ) { :ok , &quot;123&quot; }","ref":"Punt.html#value/0","title":"Punt.value/0","type":"function"},{"doc":"","ref":"Punt.Parser.html","title":"Punt.Parser","type":"module"},{"doc":"","ref":"Punt.Parser.html#integer/0","title":"Punt.Parser.integer/0","type":"function"},{"doc":"","ref":"Punt.Parser.html#string/0","title":"Punt.Parser.string/0","type":"function"}]